package knosso;

import java.util.*;

/**
 * Title:        Knosso
 * Description:  SImulazione di un labirinto
 * Copyright:    Copyright (c) 2001
 * Company:      Universit di Milano
 * @author Sara
 * @version 1.0
 */

public class DisjointSets {
  List[] sets;
  int numSets;

  public DisjointSets( Collection objs ) {
    numSets = objs.size();
    sets = new List[numSets];
    Iterator it = objs.iterator();
    for( int i = 0 ; i < numSets ; i++ ) {
      sets[i] = new LinkedList();
      sets[i].add( it.next() );
    }
  }

  public int findSet(Object o) {
    for( int i=0 ; i < sets.length ; i++ ) {
      if( sets[i].contains(o) ) return i;
    }
    return -1;
  }

  public void uniteSets( int set1 , int set2 ) {
    if( numSets <= 1 || sets[set1].isEmpty() || sets[set2].isEmpty() ) return;
    sets[set2].addAll(sets[set1]);
    sets[set1].clear();
    numSets--;
  }

  public boolean singleSet() {
    int max = 0;
    for( int i=0 ; i < sets.length ; i++ ) {
      max = (sets[i].size()>max)?sets[i].size():max;
      if( sets[i].size() == numSets ) return true;
    }
    System.out.println( max) ;
    return false;
  }

  public void uniteIfDifferent( Object a , Object b ) {
    int setA = findSet(a);
    int setB = findSet(b);
    if( setA != setB ) uniteSets( setA , setB );
  }

}